<?php
define('SETUP_dumperpath', '/opt/withings/withings-dumper/');
define('SETUP_dumpcmd', 'python3 '.SETUP_dumperpath.'dump.py -c '.SETUP_dumperpath.'#CONF# --startdate=`date +%s -d "#STARTDATE#"` --enddate=`date +%s -d now`');
define('INFLUX_HOST','127.0.0.1');
define('INFLUX_PORT',8086);
define('INFLUX_USER','admin');
define('INFLUX_PASS','password');
define('INFLUX_DB','bodydata');

require_once 'vendor/autoload.php';

$name = 'person1';$days = 5;
echo "getting API Data for last $days days for $name... \n";flush();
processData2influx(getAPIdata(SETUP_dumpcmd, $name, $days),$name);
echo "\n";
$name = 'person2';$days = 5;
echo "getting API Data for last $days days for $name... \n";flush();
processData2influx(getAPIdata(SETUP_dumpcmd, $name, $days),$name);
echo "\n";

//******* FUNCTIONS



function processData2influx($data,$name) {
	if(!empty($data)) {
		$database = InfluxDB\Client::fromDSN(sprintf('influxdb://%s:%s@%s:%s/%s', INFLUX_USER, INFLUX_PASS, INFLUX_HOST, INFLUX_PORT, INFLUX_DB));
		if(empty($database)) die("ERROR connecting to influxdb!\n");
		foreach ($data as $value) {
			if(empty($value["deviceid"])) $value["deviceid"] = 0;
			if(!empty($value["weight"]) && !empty($value["fat_ratio"])) {
				$points = array(
								new \InfluxDB\Point(
										'weight', 
										$value["weight"], 
										['name' => $name],
										['0' => false],
										$value["date"]
								),
								new \InfluxDB\Point(	
										'fat', 
										$value["fat_ratio"], 
										['name' => $name],
										['device' => intval($value["deviceid"])],
										$value["date"]
								)
				);
			} elseif (!empty($value["weight"])) {
				$points = array(
								new \InfluxDB\Point(
										'weight', 
										$value["weight"], 
										['name' => $name],
										['device' => intval($value["deviceid"])],
										$value["date"]
								)
				);			
			}
			// we are writing unix timestamps, which have a second precision
			echo ".";
			flush();
			$result = $database->writePoints($points, \InfluxDB\Database::PRECISION_SECONDS);
		}
	} else {
		echo "Nothing to process... \n";
	}
}



function getAPIdata($cmd, $confname, $days = 1) {
	$cmd = str_replace('#CONF#', 'config.'.$confname.'.json', $cmd);
	$cmd = str_replace('#STARTDATE#', $days.' days ago', $cmd);
	//die($cmd);
	$raw = shell_exec($cmd);
	$raw = explode("\n", $raw);
	$out = array();
	$i = 0;
	foreach ($raw as $retval) {

		$dataarray = json_decode($retval,true);
		if(json_last_error() == JSON_ERROR_NONE && !empty($dataarray) && is_array($dataarray)) {
			if($dataarray["weight"] > 1 && $dataarray["raw"]["date"] > 946684800) {
				$out[$i]["weight"] = (float)$dataarray["weight"];
				if(!empty($dataarray["raw"]["date"])) $out[$i]["date"]    = intval($dataarray["raw"]["date"]);
				if(!empty($dataarray["raw"]["deviceid"])) $out[$i]["deviceid"]    = intval($dataarray["raw"]["deviceid"]);
				if(!empty($dataarray["fat_ratio"])) $out[$i]["fat_ratio"] = (float)$dataarray["fat_ratio"];
				++$i;
			}
		}
		unset($dataarray);
	}
	return $out;
}



